Bug 1977535 - Review Request: python-howdoi - Instant coding answers via the command line
Summary: Review Request: python-howdoi - Instant coding answers via the command line
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Davide Cavalca
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1977534
Blocks:
TreeView+ depends on / blocked
 
Reported: 2021-06-30 00:57 UTC by Michel Alexandre Salim
Modified: 2021-07-10 01:13 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-07-10 00:48:48 UTC
Type: ---
dcavalca: fedora-review+


Attachments (Terms of Use)

Description Michel Alexandre Salim 2021-06-30 00:57:08 UTC
Spec URL: https://salimma.fedorapeople.org/specs/python/python-howdoi.spec
SRPM URL: https://salimma.fedorapeople.org/specs/python/python-howdoi-2.0.16-1.fc33.src.rpm
Description: 
Sherlock, your neighborhood command-line sloth sleuth.

Are you a hack programmer? Do you find yourself constantly Googling for how to
do basic programming tasks?

Suppose you want to know how to format a date in bash. Why open your browser and
read through blogs (risking major distraction) when you can simply stay in the
console and ask howdoi:

    $ howdoi format date bash
    > DATE=`date +%Y-%m-%d`

Fedora Account System Username: salimma

Comment 1 Davide Cavalca 2021-06-30 03:57:27 UTC
Taking this review

Comment 2 Davide Cavalca 2021-06-30 03:57:36 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://docs.fedoraproject.org/en-US/packaging-guidelines/


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "Expat License", "BSD 2-clause
     "Simplified" License". 121 files have unknown license. Detailed output
     of licensecheck in /tmp/1977534-python-keep/upstream/1977535-python-
     howdoi/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[!]: Macros in Summary, %description expandable at SRPM build time.
     Note: Macros in: python3-howdoi (description)
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
     See: https://docs.fedoraproject.org/en-US/packaging-
     guidelines/#_use_rpmlint
[x]: Spec file according to URL is the same as in SRPM.


Installation errors
-------------------
INFO: mock.py version 2.11 starting (python version = 3.9.5, NVR = mock-2.11-1.fc34)...
Start: init plugins
INFO: selinux enabled
Finish: init plugins
INFO: Signal handler active
Start: run
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled package manager cache
Start: cleaning package manager metadata
Finish: cleaning package manager metadata
INFO: enabled ccache
INFO: enabled HW Info plugin
Mock Version: 2.11
INFO: Mock Version: 2.11
Finish: chroot init
INFO: installing package(s): /tmp/1977534-python-keep/upstream/1977535-python-howdoi/results/python3-howdoi-2.0.16-1.fc35.noarch.rpm
ERROR: Command failed: 
 # /usr/bin/dnf --installroot /var/lib/mock/fedora-rawhide-x86_64/root/ --releasever 35 --setopt=deltarpm=False --allowerasing --disableplugin=local --disableplugin=spacewalk install /tmp/1977534-python-keep/upstream/1977535-python-howdoi/results/python3-howdoi-2.0.16-1.fc35.noarch.rpm --setopt=tsflags=nocontexts



Rpmlint
-------
Checking: python3-howdoi-2.0.16-1.fc35.noarch.rpm
          python-howdoi-2.0.16-1.fc35.src.rpm
python3-howdoi.noarch: E: non-executable-script /usr/lib/python3.10/site-packages/howdoi/howdoi.py 644 /usr/bin/env python
python3-howdoi.noarch: W: no-manual-page-for-binary howdoi
2 packages and 0 specfiles checked; 1 errors, 1 warnings.




Source checksums
----------------
https://github.com/gleitz/howdoi/archive/v2.0.16/howdoi-2.0.16.tar.gz :
  CHECKSUM(SHA256) this package     : e32d6bce31f27862bf23007638a78ea6727ed325e863e3ea8e3b7b377f603bbf
  CHECKSUM(SHA256) upstream package : e32d6bce31f27862bf23007638a78ea6727ed325e863e3ea8e3b7b377f603bbf


Requires
--------
python3-howdoi (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)
    python3.10dist(appdirs)
    python3.10dist(cachelib)
    python3.10dist(cssselect)
    python3.10dist(keep)
    python3.10dist(lxml)
    python3.10dist(pygments)
    python3.10dist(pyquery)
    python3.10dist(requests)



Provides
--------
python3-howdoi:
    python-howdoi
    python3-howdoi
    python3.10-howdoi
    python3.10dist(howdoi)
    python3dist(howdoi)



Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review -b 1977535
Buildroot used: fedora-rawhide-x86_64
Active plugins: Shell-api, Generic, Python
Disabled plugins: SugarActivity, C/C++, R, Perl, PHP, Ocaml, Java, fonts, Haskell
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 3 Davide Cavalca 2021-06-30 04:00:32 UTC
- escape the % in the description so it doesn't get parsed as a macro
- rpmlint complains about:
python3-howdoi.noarch: E: non-executable-script /usr/lib/python3.10/site-packages/howdoi/howdoi.py 644 /usr/bin/env python
you probably need to remove the shebang (and ideally send a PR upstream)
- pytest supports excluding tests (https://docs.pytest.org/en/6.2.x/example/pythoncollection.html), can we do that instead of patching them?

Comment 4 Michel Alexandre Salim 2021-06-30 06:35:19 UTC
(In reply to Davide Cavalca from comment #3)
> - escape the % in the description so it doesn't get parsed as a macro
ack

> - rpmlint complains about:
> python3-howdoi.noarch: E: non-executable-script
> /usr/lib/python3.10/site-packages/howdoi/howdoi.py 644 /usr/bin/env python
> you probably need to remove the shebang (and ideally send a PR upstream)
will do

> - pytest supports excluding tests
> (https://docs.pytest.org/en/6.2.x/example/pythoncollection.html), can we do
> that instead of patching them?
right, was thinking of doing that. it will add a dependency on pytest (for the annotations) but if upstream doesn't want to take it we can just carry it ourselves

Comment 5 Michel Alexandre Salim 2021-06-30 06:36:29 UTC
oh, we don't even need that with `--deselect`. duh.

Comment 6 Michel Alexandre Salim 2021-06-30 16:48:15 UTC
Spec URL: https://salimma.fedorapeople.org/specs/python/python-howdoi.spec
SRPM URL: https://salimma.fedorapeople.org/specs/python/python-howdoi-2.0.16-2.fc33.src.rpm

- Escape \%s in description
- Use `--deselect` to temporarily skip expensive tests

Comment 7 Davide Cavalca 2021-06-30 23:14:40 UTC
Approved, but please also fix the shebang.

Comment 8 Michel Alexandre Salim 2021-06-30 23:20:33 UTC
yup, and acutally fix the escape properly

Comment 9 Michel Alexandre Salim 2021-06-30 23:51:33 UTC
$ fedpkg request-repo python-howdoi 1977535
https://pagure.io/releng/fedora-scm-requests/issue/35417

Comment 10 Gwyn Ciesla 2021-07-01 00:01:54 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-howdoi

Comment 11 Fedora Update System 2021-07-01 01:11:57 UTC
FEDORA-2021-84a5d956c1 has been submitted as an update to Fedora 34. https://bodhi.fedoraproject.org/updates/FEDORA-2021-84a5d956c1

Comment 12 Fedora Update System 2021-07-01 01:13:23 UTC
FEDORA-2021-535d01eecb has been submitted as an update to Fedora 33. https://bodhi.fedoraproject.org/updates/FEDORA-2021-535d01eecb

Comment 13 Fedora Update System 2021-07-02 01:08:26 UTC
FEDORA-2021-84a5d956c1 has been pushed to the Fedora 34 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-84a5d956c1 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-84a5d956c1

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 14 Fedora Update System 2021-07-02 01:52:39 UTC
FEDORA-2021-535d01eecb has been pushed to the Fedora 33 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-535d01eecb \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-535d01eecb

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 15 Fedora Update System 2021-07-10 00:48:48 UTC
FEDORA-2021-535d01eecb has been pushed to the Fedora 33 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 16 Fedora Update System 2021-07-10 01:13:04 UTC
FEDORA-2021-84a5d956c1 has been pushed to the Fedora 34 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.